/*
				XF551.S
		seriovy  kanal  na  centronis
			ver. 1.0   5.jan.94
						Marek &	[PZ]
*/

;			*** T A B U L K A   R Y CH L O S T I ***
;	rychl.		wait1	wait2	waitp	|	wait	waitp
;	38908		6		2		2		|	10		2
;	19200		17		10		0		|	28		3(0)
;	 9600		35		28		0		|	62		0
;	 4800		-		-		-		|	133		3
;	 2400		136		140		0		|	275(272)	0

/*		void int_povel( void )			*/
/* 		int sio_send( t_sio *t )		*/
/* 		int sio_receive( t_sio *t )		*/

/*		t_sio : long timeout
				int wait2
				int wait1
				char *buf
				int naraznik
				int dlzka
				int waitp
*/

	import	povel
	import	povel_buf
	import	povel_sio
	export	trap_0
	export	int_povel
	export	sio_send
	export	sio_receive

	TEXT

/* -------  TRAP #0  -------- */

trap_0: tst.w	d0
		bpl		trap_end
		cmpa.l	#0,a0
		beq		trap_end
		cmp.w	#$ABCD,d0
		beq		tr_jsr
		lsl.w	#2,d0
		and.w	#$1f,d0
		jmp		tr_rb(pc,d0)
tr_jsr:	jsr		(a0)
		bra.b	trap_end
tr_rb:	move.b	(a0),d0
		bra.b	trap_end
tr_rw:	move.w	(a0),d0
		bra.b	trap_end
tr_rl:	move.l	(a0),d0
		bra.b	trap_end
		nop
		bra.b	trap_end
tr_wb:	move.b	d1,(a0)
		bra.b	trap_end
tr_ww:	move.w	d1,(a0)
		bra.b	trap_end
tr_wl:	move.l	d1,(a0)
		nop
trap_end:
		rte

/* -------- SIO ------- */

int_povel:
		movem.l	d0-d7/a0-a3,-(sp)

		lea		povel_sio,a3
		jsr		receiv(PC)
		lea		povel_buf,a0
		move.b	d0,5(a0)		;return kod

		bne		no_povel
		move.w	#1,povel
no_povel:

		movem.l	(sp)+,d0-d7/a0-a3
		move.b	#%11111110,$fffa11		;IPRB end of int.
		rte


sio_send:
		movem.l	d1-d7/a1-a3,-(sp)
		move.l	a0,a3
		move.l	#send,-(sp)
		move.w	#38,-(sp)		;supexec
		trap	#14
		addq.l	#6,sp

		movem.l	(sp)+,d1-d7/a1-a3
		rts

sio_receive:
		movem.l	d1-d7/a1-a3,-(sp)
		move.l	a0,a3
		move.l	#receiv,-(sp)
		move.w	#38,-(sp)		;supexec
		trap	#14
		addq.l	#6,sp

		movem.l	(sp)+,d1-d7/a1-a3
		rts

/*--------- send -----------*/
 
send:	movem.l	(a3)+,d1-d2/a0
		movem.w	(a3)+,d4-d6
		subq.w	#1,d5		;dl-1
		moveq.l	#0,d3

		move	sr,-(sp)
		ori		#$0700,sr

		lea		$ff8800,a1
		lea		$ff8802,a2

		move.b	#7,(a1)
		move.b	(a1),d0
		andi.b	#$3f,d0
		ori.b	#$40,d0
		move.b	d0,(a2)
		move.b	#14,(a1)	;port A

		move.b	(a1),d1
		andi.b	#$df,d1		;5.bit = 0

scbyte:	move.b	(a0)+,d3	;data
		or.w	d4,d3		;+ STOP bit
		move.b	d1,(a2)		;vystup START bitu

		move.w	d2,d7		;- wait - ( 24 + 10*wait + 2*waitp )
sw1:	dbra.w	d7,sw1
		lsr.w	d6,d7

		lsr.w	#4,d7		; ( +14 )

scbit:	lsr.w	#1,d3		;data -> <X>  ( 36 )
		moveq.l	#0,d0
		roxr.b	#3,d0		;5.bit
		or.b	d1,d0		;povodna h.
		move.b	d0,(a2)		; vystup

		move.w	d2,d7		;- wait - ( 24 + 10*wait + 2*waitp )
sw2:	dbra.w	d7,sw2
		lsr.w	d6,d7

		move.w	d3,d3		;priznaky  , ( 14 )
		bne.s	scbit		;next bit

		nop
		nop
		dbra.w	d5,scbyte	;next byte

		move	(sp)+,sr
		moveq.l	#0,d0		; 0  O.K.
		rts

/*---------- receive ------------*/

receiv:	movem.l	(a3)+,d1-d2/a0
		movem.w	(a3)+,d4-d6
		move.w	d4,a3			;naraznik  ($80)
		subq.w	#1,d5			;dl-1

		move	sr,-(sp)
		ori		#$0700,sr

		lea		$ff8800,a1
		lea		$ff8802,a2
/*		lea		$ff9203,a4	*/		;port joystick - clock

		move.b	#7,(a1)
		move.b	(a1),d0
		andi.b	#$3f,d0		;port B = vstup
		ori.b	#$40,d0
		move.b	d0,(a2)
		move.b	#14,(a1)	;port A
		move.b	(a1),d0
		ori.b	#$20,d0		;5.bit = 1
		move.b	d0,(a2)		;port A
		move.b	#15,(a1)	;port B
		moveq.l	#0,d4

rcbyte:	move.w	a3,d3		;naraznik

		moveq.l	#1,d0		;0.bit
		and.b	(a1),d0		;STOP bit
		beq.s	err_ov		;err overflov ( chyba start bitu )

		move.l	d1,d7		;timeout
rwstrt:	moveq.l	#1,d0		;0.bit
		and.b	(a1),d0		;START bit ?
		beq.s	rcount		;ano
		btst.b	#0,$fffffa01	;Centronics BUSY	= Povel
		beq.s	rwstrt
		subq.l	#1,d7
		bne.s	rwstrt		;cakaj
		bra.s	err_to		;err timeout

rcount:	move.b	(a0),d4				;impulz ******  [d4,(a4)]
		not.w	d4					;		******
		move.l	d2,d7		;- vypocet dl start bitu -
		swap.w	d7
		add.w	d2,d7
		addq.w	#4,d7
rw1:	dbra	d7,rw1		; ( 76 + 10*(w1+w2) + 2*wp )
		lsr.w	d6,d7
		
rcbit:	move.l	d2,d7		;			( 76 + 10*w1 + 10*w2 + 2*wp )
rw2:	dbra	d7,rw2		;wait1
		swap.w	d7

		move.b	(a1),d0		;vstup
		move.b	(a0),d4				;impulz ******	[d4,(a4)]
		not.w	d4					;		******
		ror.w	d6,d4		;waitp
		lsr.b	#1,d0		;bit -> <X>
		roxr.b	#1,d3		;<X> -> data

rw3:	dbra	d7,rw3		;wait2

		bcc.s	rcbit		;next bit	( -	 -	-	-	-	-	- )

		move.b	d3,(a0)+	;data -> buf

		move.w	d2,d7
rw4:	dbra	d7,rw4		;wait1

		dbra.w	d5,rcbyte

		moveq.l	#0,d0		; 0  O.K.
rend:	move	(sp)+,sr
		rts

err_to:	moveq.l	#-2,d0		; -2 TIMEOUT
		bra.s	rend

err_ov:	moveq.l	#-3,d0		; -3 OVERFLOW
		bra.s	rend

